//Li-fi transmitter Borrowed from SaadOjo https://github.com/SaadOjo/DIY_Li-Fi/blob/master/transmiter_code/transmiter_code.ino

//transmitter stuff
#define TRANSMIT_LED1 12
#define TRANSMIT_LED2 10
#define TRANSMIT_LED3 11
#define SAMPLING_TIME 5

//Declaration
bool led_state = false;
bool button_state = false;
bool transmit_data1 = true;
bool transmit_data2 = true;
int bytes_counter1 = 17;
int bytes_counter2 = 17;
int total_bytes1;
int total_bytes2;

//Keypad Stuff
#include "Adafruit_NeoTrellis.h"

Adafruit_NeoTrellis trellis;

bool red=false;
bool blue=false;
bool purple=false;
bool penred=true; 

int colors[16]={1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,2}; //0 is off, 1 is blue, 2 is red, 3 is purple, this holds whole system state
char redcolor[17]={95,79,79,79,79,79,79,79,79,79,79,79,79,79,79,79,89}; //this is the red message 0 is off, 1 is red
char bluecolor[17]={95,89,79,79,79,79,79,79,79,79,79,79,79,79,79,79,79}; //this is the blue message 0 is off, 1 is blue



//define a callback for key presses
TrellisCallback blink(keyEvent evt){
  // Check is the pad pressed?
  if (evt.bit.EDGE == SEESAW_KEYPAD_EDGE_RISING) {
    if(evt.bit.NUM==0){ //pen selection for blue
      penred=false;
      trellis.pixels.setPixelColor(0, 0,0,255);
      trellis.pixels.setPixelColor(15, 20,0,0);
    }
    else if(evt.bit.NUM==15){ //pen selection for red
      penred=true;
      trellis.pixels.setPixelColor(0, 0,0,20);
      trellis.pixels.setPixelColor(15, 255,0,0);
    }
    else{
      switch(colors[evt.bit.NUM]){
        case 0://Led is off
             if(penred){
              trellis.pixels.setPixelColor(evt.bit.NUM, 255,0,0); //on rising
              colors[evt.bit.NUM]=2;
              redcolor[evt.bit.NUM+1]=89;
              }
              else{
              trellis.pixels.setPixelColor(evt.bit.NUM, 0,0,255); //on rising
              colors[evt.bit.NUM]=1;
              bluecolor[evt.bit.NUM+1]=89;
              }
        break;
        case 1://led is blue
             if(penred){
              trellis.pixels.setPixelColor(evt.bit.NUM, 255,0,255); //on rising
              colors[evt.bit.NUM]=3;
              redcolor[evt.bit.NUM+1]=89;
              }
              else{
              trellis.pixels.setPixelColor(evt.bit.NUM, 0); //on rising
              colors[evt.bit.NUM]=0;
              bluecolor[evt.bit.NUM+1]=79;
              }
        break;
        case 2://led is red
              if(penred){
              trellis.pixels.setPixelColor(evt.bit.NUM, 0); //on rising
              colors[evt.bit.NUM]=0;
              redcolor[evt.bit.NUM+1]=79;
              }
              else{
              trellis.pixels.setPixelColor(evt.bit.NUM, 255,0,255); //on rising
              colors[evt.bit.NUM]=3;
              bluecolor[evt.bit.NUM+1]=89;
              }
        break;
        case 3://led is purple
              if(penred){
              trellis.pixels.setPixelColor(evt.bit.NUM, 0,0,255); //on rising
              colors[evt.bit.NUM]=1;
              redcolor[evt.bit.NUM+1]=79;
              }
              else{
              trellis.pixels.setPixelColor(evt.bit.NUM, 255,0,0); //on rising
              colors[evt.bit.NUM]=2;
              bluecolor[evt.bit.NUM+1]=79;
              }
        break;

    }
    }
  } 


    


  // Turn on/off the neopixels!
  trellis.pixels.show();

  return 0;
}

void setup() {
  Serial.begin(9600);
  //while(!Serial);
  pinMode(TRANSMIT_LED1,OUTPUT);
  pinMode(TRANSMIT_LED2,OUTPUT);
  pinMode(TRANSMIT_LED3,OUTPUT);
  total_bytes1 = strlen(redcolor);
  total_bytes2 = strlen(bluecolor);
  digitalWrite(TRANSMIT_LED3,HIGH);
  
  if (!trellis.begin()) {
    Serial.println("Could not start trellis, check wiring?");
    while(1);
  } else {
    Serial.println("NeoPixel Trellis started");
  }

  //activate all keys and set callbacks
  for(int i=0; i<NEO_TRELLIS_NUM_KEYS; i++){
    trellis.activateKey(i, SEESAW_KEYPAD_EDGE_RISING);
    trellis.activateKey(i, SEESAW_KEYPAD_EDGE_FALLING);
    trellis.registerCallback(i, blink);
  }

  //do a little animation to show we're on
  for (uint16_t i=0; i<trellis.pixels.numPixels(); i++) {
    trellis.pixels.setPixelColor(i, Wheel(map(i, 0, trellis.pixels.numPixels(), 0, 255)));
    trellis.pixels.show();
    delay(50);
  }
  for (uint16_t i=0; i<trellis.pixels.numPixels(); i++) {
    trellis.pixels.setPixelColor(i, 0x000000);
    trellis.pixels.show();
    delay(50);
  }
  //set the pen buttons
trellis.pixels.setPixelColor(0, 0,0,20);
trellis.pixels.setPixelColor(15, 20,0,0);
trellis.pixels.show();
}

void loop() {
  trellis.read();  // interrupt management does all the work! :)


//Transmit the message
while(transmit_data1)
   {
    transmit_byte(redcolor[total_bytes1 - bytes_counter1],TRANSMIT_LED1);
    bytes_counter1--;
      if(bytes_counter1 == 0)
      {
        transmit_data1 = false;
      }
      trellis.read();
     //delay(100);
   }
   transmit_data1 = true;
   bytes_counter1 = total_bytes1;



   while(transmit_data2)
   {
    transmit_byte(bluecolor[total_bytes2 - bytes_counter2],TRANSMIT_LED2);
    bytes_counter2--;
      if(bytes_counter2 == 0)
      {
        transmit_data2 = false;
      }
      trellis.read();

   }
   transmit_data2 = true;
   bytes_counter2 = total_bytes2;



  delay(20); //the trellis has a resolution of around 60hz
}


/******************************************/

// Input a value 0 to 255 to get a color value.
// The colors are a transition r - g - b - back to r.
uint32_t Wheel(byte WheelPos) {
  if(WheelPos < 85) {
   return trellis.pixels.Color(WheelPos * 3, 255 - WheelPos * 3, 0);
  } else if(WheelPos < 170) {
   WheelPos -= 85;
   return trellis.pixels.Color(255 - WheelPos * 3, 0, WheelPos * 3);
  } else {
   WheelPos -= 170;
   return trellis.pixels.Color(0, WheelPos * 3, 255 - WheelPos * 3);
  }
  return 0;
}

void transmit_byte(char data_byte, int LED_PIN)
{
  digitalWrite(LED_PIN,HIGH); 
  delay(SAMPLING_TIME);
  for(int i = 0; i < 8; i++)
  {
    digitalWrite(LED_PIN,!((data_byte >> i) & 0x01)); 
    delay(SAMPLING_TIME);
  }
 digitalWrite(LED_PIN,LOW); //Return to IDLE state
 delay(SAMPLING_TIME);
}
